
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                        %%
%% HttpClient package                                                     %%
%%                                                                        %%
%%  (c) 2000 Universit catholique de Louvain. All Rights Reserved.       %%
%%  The development of this software is supported by the PIRATES project  %%
%%  at the Universit catholique de Louvain. This file is subject to the  %%
%%  general Mozart license.                                               %%
%%                                                                        %%
%%  Author: Valentin Mesaros                                              %%
%%                                                                        %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
import
   OS 
export
   getTime:GetTime
   setClock:SetClock
   startClock:StartClock
   stopClock:StopClock
define
   Tempo
   ClockThread
   TLate
   MSec = 1000
   proc {Clock Late OldTime N}
      Dif
      NewTime
      OldTempo
   in
      {Delay Late}
      {Exchange Tempo OldTempo thread OldTempo+{Access TLate} end}
      NewTime = {OS.time}
      if NewTime \= OldTime then
	 Dif = NewTime*MSec-{Access Tempo}
	 if Dif \= 0 then ToAdd in
	    ToAdd = {Float.toInt {Int.toFloat Dif*Late}/{Int.toFloat MSec}}
	    if (Late+ToAdd) > 0 then
	       {Assign TLate Late+ToAdd}
	    else
	       {Assign TLate 1}
	    end
	 else
	    {Assign TLate Late}
	 end
	 %{System.show diff#Dif#OldTime#NewTime#{Access Tempo}#N#{Access TLate}}
      end
      {Clock Late NewTime N+1}
   end
   fun {GetTime}
      {Access Tempo}
   end
   proc {SetClock Begin}
      {Assign Tempo Begin}
   end
   proc {StartClock Late}
      thread
	 {Assign ClockThread {Thread.this}}
	 {Thread.setPriority {Access ClockThread} high}
	 {Clock Late {OS.time} 0}
      end
   end
   proc {StopClock}
      if {Access ClockThread} \= nil andthen {Thread.state {Access ClockThread}} \= terminated then
	 {Thread.terminate {Access ClockThread}}
	 {Assign ClockThread nil}
      end
      {Assign Tempo 0}
      {Assign TLate 0}
   end
in
   {NewCell 0 Tempo}
   {NewCell 0 TLate}
   {NewCell nil ClockThread}
end % end of Clock functor


